program Tags;
{$APPTYPE CONSOLE}
uses
  SysUtils,
  Classes,
  uTags in 'uTags.pas',
  uFiles in 'uFiles.pas';

const VERSION = '0.02';

  procedure Syntax;
  begin
    Writeln;
    Writeln('Syntax:   ' + ExtractFileName(ParamStr(0)) + ' <arg> [<arg>] ...');
    Writeln;
    Writeln('    <arg>:');
    Writeln('           -h, -? .... show this help');
    Writeln('           -r ........ recursive scanning on');
    Writeln('           -r- ....... recursive scanning off');
    Writeln('           -cz ....... exclude czech characters from high-ascii check.');
    Writeln('           -cz- ...... include czech characters in high-ascii check.');
    Writeln('           Anything else is considered a file mask to be processed.');
    Writeln;
  end;

  procedure PrintList(List: TStringList);
  var i: integer;
  begin
    if List <> nil then
      begin
      for i := 0 to Pred(List.Count) do
        Writeln(Format('%5d', [Integer(List.Objects[i])]) + #9 + List[i]);
      if List.Count > 0 then
        Writeln;
      end;
  end;

const CzechChars = ['','','','','','','','','','','','','','','',
                    '','','','','','','','','','','','','','',''];

var TagList, EntityList, HighAsciiList: TStringList;
    Recursive: boolean;
    SkipAsciiHigh: TAnsiCharSet;
    i, n: integer;
    s: string;

begin
  try
    Writeln('Tags v' + VERSION + '                                                       (c) 2010 Pepak');
    Writeln('-------------------------------------------------------------------------------');
    n := ParamCount;
    TagList := TStringList.Create;
    try
      EntityList := TStringList.Create;
      try
        HighAsciiList := TStringList.Create;
        try
          Recursive := False;
          SkipAsciiHigh := [];
          if n = 0 then
            Syntax
          else
            for i := 1 to n do
              begin
              s := ParamStr(i);
              if (s = '-?') or (s = '-h') then
                Syntax
              else if s = '-r' then
                Recursive := True
              else if s = '-r-' then
                Recursive := False
              else if s = '-cz' then
                SkipAsciiHigh := SkipAsciiHigh + CzechChars
              else if s = '-cz-' then
                SkipAsciiHigh := SkipAsciiHigh - CzechChars
              else
                FindHtmlTagsInFiles(s, Recursive, TagList, EntityList, HighAsciiList, SkipAsciiHigh);
              end;
          PrintList(TagList);
          PrintList(EntityList);
          PrintList(HighAsciiList);
        finally
          HighAsciiList.Free;
          end;
      finally
        EntityList.Free;
        end;
    finally
      TagList.Free;
      end;
  except
    on E: Exception do
      begin
      Writeln('ERROR ' + E.ClassName + ': ' + E.Message);
      Halt(255);
      end;
    end;
end.
